unit Unit2;

{$MODE Delphi}

interface

uses
  LCLIntf, LCLType, LMessages, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons, Grids;

type
  TForm2 = class(TForm)
    grid: TDrawGrid;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    procedure LabeledEdit2Change(Sender: TObject);
    procedure LabeledEdit1Change(Sender: TObject);
    procedure gridMouseLeave(Sender: TObject);
    procedure gridMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure gridTopLeftChanged(Sender: TObject);
    procedure gridEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure gridSelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure gridDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
  private
    { Private declarations }
  public

    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

Uses Unit1;

{$R *.lfm}

procedure TForm2.gridDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
  State: TGridDrawState);
begin
 with Grid.Canvas do
 begin

  if ARow = 0 then
  begin
   if ACol = 0 then
   begin
     Font.Name := 'Arial';
     Font.Color := 0;
     Font.Style := [];
     Font.Size := 10;

     TextRect(Rect, Rect.Left+((Rect.Right-Rect.left) - TextWidth('Code')) div 2
                  , Rect.Top+((Rect.Bottom-Rect.Top) - TextHeight('Code')) div 2, 'Code');
   end
   else
   begin
     Font.Name := 'Arial';
     Font.Color := 0;
     Font.Style := [];
     Font.Size := 10;

     TextRect(Rect, Rect.Left + ((Rect.Right-Rect.Left) - TextWidth('Character')) div 2
                  , Rect.Top+((Rect.Bottom-Rect.Top) - TextHeight('Character')) div 2, 'Character');
   end;
  end
  else
  begin

   if ACol = 0 then
   begin
     Font.Name := 'Arial';
     Font.Style := [];
     Font.Color := 0;
     Font.Size := 9;

     TextOut(Rect.Left+ ((Rect.Right-Rect.Left) - TextWidth(inttostr(ARow))) div 2
            ,Rect.Top+ ((Rect.Bottom-Rect.Top) - TextHeight(inttostr(ARow))) div 2, inttostr(ARow));

   end
   else
   begin

     Font.Name := Form1.Combobox1.Text;
     Font.Style := [];
     Font.Color := 0;
     Font.Size := 14;

     Brush.Color := clWhite;
     Pen.Style := psClear;
     Rectangle(Rect.Left+ ((Rect.Right-Rect.Left) - Form1.Longest) div 2
            ,Rect.Top,
            Rect.Left+ ((Rect.Right-Rect.Left) + Form1.Longest) div 2
            ,Rect.Bottom);

     TextOut(Rect.Left+ ((Rect.Right-Rect.Left) - TextWidth(chr(ARow))) div 2
            ,Rect.Top+ ((Rect.Bottom-Rect.Top) - TextHeight(chr(ARow))) div 2, chr(ARow));
   end;


  end;
 end;

end;

procedure TForm2.gridEndDrag(Sender, Target: TObject; X, Y: Integer);
begin
   self.LabeledEdit1.Text := inttostr(Grid.Selection.Top);
   self.LabeledEdit2.Text := inttostr(Grid.Selection.Bottom);

end;

procedure TForm2.gridMouseLeave(Sender: TObject);
begin
   self.LabeledEdit1.Text := inttostr(Grid.Selection.Top);
   self.LabeledEdit2.Text := inttostr(Grid.Selection.Bottom);

end;

procedure TForm2.gridMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   self.LabeledEdit1.Text := inttostr(Grid.Selection.Top);
   self.LabeledEdit2.Text := inttostr(Grid.Selection.Bottom);

end;

procedure TForm2.gridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
   self.LabeledEdit1.Text := inttostr(Grid.Selection.Top);
   self.LabeledEdit2.Text := inttostr(Grid.Selection.Bottom);

end;

procedure TForm2.gridTopLeftChanged(Sender: TObject);
begin
   self.LabeledEdit1.Text := inttostr(Grid.Selection.Top);
   self.LabeledEdit2.Text := inttostr(Grid.Selection.Bottom);

end;

procedure TForm2.LabeledEdit1Change(Sender: TObject);
Var GSel: TGridRect;
begin
 if LabeledEdit1.Text <> '' then
 begin
  Gsel := Grid.Selection;
  GSel.Top := strtoint(LabeledEdit1.text);
  //GSel.Bottom := strtoint(LabeledEdit2.text);
  Grid.Selection := GSel;
 end;

end;

procedure TForm2.LabeledEdit2Change(Sender: TObject);
var GSel: TGridRect;
begin
 if LabeledEdit2.Text <> '' then
 begin
  Gsel := Grid.Selection;
  //GSel.Top := strtoint(LabeledEdit1.text);
  GSel.Bottom := strtoint(LabeledEdit2.text);
  Grid.Selection := GSel;
 end;

end;

procedure TForm2.SpeedButton1Click(Sender: TObject);
begin

  ModalResult := mrOk;
end;

procedure TForm2.SpeedButton2Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

end.
